/* $Id: crashdlg.c,v 1.1 2000/01/30 16:56:38 rsmith Exp $
 * This file is part of xplanets
 * Copyright (C) 2000  R.F. Smith
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * You can contact the author at the following addresses:
 *     e-mail: rsmith@xs4all.nl
 * snail-mail: R.F. Smith
 *             Dr. Hermansweg 36
 *             5624 HR Eindhoven
 *             The Netherlands
 *
 * $Log: crashdlg.c,v $
 * Revision 1.1  2000/01/30 16:56:38  rsmith
 * Initial revision
 *
 */

#include <gtk/gtk.h>
#include "planets.h"

/*************** IMPORTS **************/
extern GtkWidget *new_btn;      /* from mainwin.c */
extern GtkWidget *run_toggle;   /* from mainwin.c */

/*************** EXPORTS **************/ 
void show_crash_dialog (int i);

/********** STATIC DATA **********/
static GtkWidget *crash_dialog = NULL;

/********** STATIC FUNCTIONS **********/
static void delete_crash_dialog (GtkWidget *widget, gpointer *data);

/*********** IMPLEMENTATION ***********/
void 
show_crash_dialog (int i)
{
  char *txt = "Oops";
  GtkWidget *frame = NULL;
  GtkWidget *vbox = NULL;
  GtkWidget *msg_label = NULL;
  GtkWidget *name_label = NULL;
  GtkWidget *close_btn = NULL;

  gtk_widget_set_sensitive (run_toggle, FALSE);

  crash_dialog = gtk_window_new (GTK_WINDOW_DIALOG); 
  gtk_window_set_title(GTK_WINDOW (crash_dialog), txt);
  gtk_window_set_wmclass (GTK_WINDOW (crash_dialog),
                          txt, PROGRAM);
  gtk_window_set_position(GTK_WINDOW (crash_dialog), 
                          GTK_WIN_POS_CENTER);

  frame = gtk_frame_new (txt);
  gtk_container_border_width(GTK_CONTAINER (frame), 2);
  gtk_container_add (GTK_CONTAINER(crash_dialog), frame);

  vbox = gtk_vbox_new (FALSE, 2);
  gtk_container_border_width(GTK_CONTAINER (vbox), 2);
  gtk_container_add (GTK_CONTAINER (frame), vbox);
  
  msg_label = gtk_label_new ("You have crashed on");
  gtk_box_pack_start(GTK_BOX(vbox), msg_label, FALSE, FALSE, 0);

  name_label = gtk_label_new (planet[i].name);
  gtk_box_pack_start(GTK_BOX(vbox), name_label, FALSE, FALSE, 0);

  close_btn = gtk_button_new_with_label("Close");
  gtk_box_pack_start(GTK_BOX(vbox), close_btn, FALSE, FALSE, 0);
  gtk_signal_connect (GTK_OBJECT(close_btn), "clicked", 
                      GTK_SIGNAL_FUNC(delete_crash_dialog), NULL);

  gtk_widget_show_all (crash_dialog);
}

/*  static void */
/*  label_printf (GtkLabel *label, const char *fmt, ...) */
/*  { */
/*    char buf[LABELSIZE]; */

/*    if (label != NULL && fmt != NULL) { */
/*      va_list ap; */
/*      va_start (ap, fmt); */
/*      vsnprintf (buf, LABELSIZE, fmt, ap); */
/*      gtk_label_set_text (label, buf); */
/*      va_end (ap); */
/*    } */
/*  } */

static void 
delete_crash_dialog (GtkWidget *widget, gpointer *data)
{
  gtk_widget_destroy(crash_dialog);
  crash_dialog = NULL;
  gtk_button_clicked (GTK_BUTTON (new_btn));
  gtk_widget_set_sensitive (run_toggle, TRUE);

}

